<template>
  <el-main>
    <el-row>
      <el-col :span="12">
        <label>input</label>
      </el-col>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="input"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="8">
        <el-button @click="encode" type="primary" round>エンコード！</el-button>
      </el-col>
      <el-col :span="2" :offset="2">
        <el-button @click="decode" type="primary" round>デコード！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <label>output</label>
      </el-col>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>

</template>

<script>
export default {
  data() {
    return {
      input: "",
      output: "",
    }
  },
  methods: {
    encode() {
      const utf8str = String.fromCharCode.apply(null, new TextEncoder().encode(this.input))
      this.output = btoa(utf8str)
    },
    decode() {
      const decoded_utf8str = atob(this.input)
      const decoded_arr = new Uint8Array(Array.prototype.map.call(decoded_utf8str, c => c.charCodeAt()))
      this.output = new TextDecoder().decode(decoded_arr)
    }
  }
}
</script>
